#include <gb/gb.h>

#include "./levels.tileset.h"
#include "./level01.tilemap.h"

#define TILE_WIDTH         8
#define SCREEN_WIDTH_TILE  20
#define SCREEN_WIDTH_PX    SCREEN_WIDTH_TILE * TILE_WIDTH

#define SPRITE_OFFSET_X  8
#define SPRITE_OFFSET_Y  16

#define TILE_OFFSET      128
#define TILE_PADDLE_L    TILE_OFFSET + 12
#define TILE_PADDLE_C    TILE_OFFSET + 13
#define TILE_PADDLE_R    TILE_OFFSET + 14
#define TILE_BALL        TILE_OFFSET + 15

#define SPRITE_BALL      0
#define SPRITE_PADDLE_L  1
#define SPRITE_PADDLE_C  2
#define SPRITE_PADDLE_R  3

#define PADDLE_Y         SPRITE_OFFSET_Y + 17 * TILE_WIDTH
#define PADDLE_WIDTH     3 * TILE_WIDTH
#define PADDLE_ORIG_X    SPRITE_OFFSET_X + (SCREEN_WIDTH_PX - PADDLE_WIDTH) / 2

UINT8 BALL_X = 50;
UINT8 BALL_Y = 120;
UINT8 PADDLE_X = PADDLE_ORIG_X;

void main(void) {
    set_bkg_data(TILE_OFFSET, LEVELS_TILESET_TILE_COUNT, LEVELS_TILESET);
    set_bkg_tiles(0, 0, LEVEL01_TILEMAP_WIDTH, LEVEL01_TILEMAP_HEIGHT, LEVEL01_TILEMAP);
    SHOW_BKG;

    set_sprite_tile(SPRITE_BALL, TILE_BALL);
    move_sprite(SPRITE_BALL, BALL_X, BALL_Y);

    set_sprite_tile(SPRITE_PADDLE_L, TILE_PADDLE_L);
    move_sprite(SPRITE_PADDLE_L, PADDLE_X, PADDLE_Y);

    set_sprite_tile(SPRITE_PADDLE_C, TILE_PADDLE_C);
    move_sprite(SPRITE_PADDLE_C, PADDLE_X + TILE_WIDTH, PADDLE_Y);

    set_sprite_tile(SPRITE_PADDLE_R, TILE_PADDLE_R);
    move_sprite(SPRITE_PADDLE_R, PADDLE_X + 2 * TILE_WIDTH, PADDLE_Y);

    SHOW_SPRITES;
}
